<?php
	header('Content-type: text/html; charset=utf-8');
	
	if ( !isset($_GET['debug']) )
		error_reporting(0);
	
	if ( !defined("HQ") || !defined("HQ") )
	{
		echo "No sneaky!";
		exit;
	}
	
	define( "SYSTEM", HQ . "system/" );
	define( "SYSTEM_URL", HQ_URL . "system/" );
	
	// Required files
	require_once SYSTEM . "assistants/utf8.php";
	require_once SYSTEM . "assistants/config.inc.php";
	require_once SYSTEM . "assistants/clerk.php";
	require_once "display_functions.php";
	
	// Initialize
	$clerk= new Clerk();
	$clerk->dbConnect();
	$clerk->loadSettings();
	
	define( "FRONTEND", "true" );
	
	loadPlugins();
	
	// Include all modules
	$defaultModules= array( "global", "design", "pages" );
	$modules= scanFolder( SYSTEM . "modules", 1 );
	
	// URL Router
	foreach ( $defaultModules as $key )
	{
		$viewFile= SYSTEM . "modules/" . $key . "/view.php";
		if ( file_exists( $viewFile ) )
		{
			include_once $viewFile;
		}
	}
	
	foreach ( $modules as $key => $val )
	{
		$viewFile= SYSTEM . "modules/" . $key . "/view.php";
		if ( file_exists( $viewFile ) )
		{
			include_once $viewFile;
		}
	}
	
	// Ok, doing something funky with URL routing.
	// Let's see how it works out...
	if ( empty( $_GET['request'] ) )
	{
		$REQUEST= $_GET;
	}
	else
	{
		$REQUEST= utf8_strtolower( $_GET['request'] );
		$params= explode( "/", $REQUEST );
		
		// Has a page been requested?
		$isPage= false;
		$getPages= $clerk->query_select( "pages" );
		while ( $page= $clerk->query_fetchArray( $getPages ) )
		{
			if ( $page['slug'] == $params[0] || $page['id'] == $params[0] )
			{
				$isPage= true;
				break;
			}
		}
		
		$paramsss= array(
			$params[0]	=>	$params[1]
		);
		
		if ( $isPage )
		{
			$paramss= array(
				'page'	=>	$params[0]
			);
		}
		
		$page= pageInfo( $params[0] );
		$module= $page['content_type'];
		
		$par= call_anchor( "url_router", array( 'map' => $paramss, 'request' => $params, 'restrict' => $module ) );
		
		$REQUEST= $par['map'];
		$_GET= $REQUEST;
	}
	
	foreach ( $modules as $key => $val )
	{
		$module= getRemappedVar( $key );
		
		if ( in_array( $key, $defaultModules ) )
		{
			if ( $module == getRemappedVar("pages") && !empty( $REQUEST['id'] ) )
			{	
				$pageDetails= pageInfo( $REQUEST[getRemappedVar("pages")] );
				$pageType= $pageDetails['content_type'];

				$layout= $pageType;
				$activeModule= $pageType;
			}
			
			continue;
		}
		
		if ( array_key_exists( $module, $REQUEST ) )
		{
			$layout= $key;
			$activeModule= $key;
			
			break;
		}
	}
	
	if ( empty( $layout ) || $layout == "pages" ) $layout= "default";
	
	$selectedPage= ( empty( $REQUEST[getRemappedVar("pages")] ) ) ? indexPage() : $REQUEST[getRemappedVar("pages")];
	foreach ( $modules as $key => $val )
	{
		$module= getRemappedVar( $key );
		
		if ( !empty( $REQUEST[getRemappedVar($key)] ) && $module == getRemappedVar("pages") )
		{
			$selectedPage= $REQUEST[getRemappedVar($key)];
			break;
		}
		
		// Not viewing a page (domain.com/?projects=id)
		elseif ( !empty( $REQUEST[getRemappedVar($key)] ) && $module != getRemappedVar("pages") )
		{
			$selectedPage= getRemappedVar($key);
			break;
		}
	}
		
	// Constants
	call_anchor( "site_init" );
	
	define( "THEME", $clerk->getSetting( "site_theme", 1 ) );
	define( "THEME_URL", HQ_URL . "site/themes/" . THEME . "/" );
	define( "LAYOUT", "layout_" . $layout . ".php" );
	define( "ACTIVE_MODULE", $activeModule );
	define( "PAGE", $selectedPage );
	
	// Check if layout exists.
	if ( file_exists( HQ . "site/themes/" . THEME . "/" . LAYOUT ) == false )
	{
		echo "Oops! Looks like your theme is missing the layout file, <em>" . LAYOUT . "</em>.<br /><br />Create this file and upload it to the root of your theme's folder. Don't forget to fill it with template tags and your custom HTML!";
		
		exit;
	}
	
	call_anchor( "site_begin" );

	require_once "themes/" . THEME . "/" . LAYOUT;
?>